#########################################################
###  YOU CAN CHANGE YOUR FSERVER2.CFG AND FSETUP.TCL  ###
###                DESTINATIONS HERE                  ###
#########################################################
set fserver2_cfg "scripts/fserver2.cfg"
set fsetup_tcl "scripts/fsetup.tcl"
#########################################################

#########################################################
#        You should not change anything bellow this     #
#  report any changes to CANUCKLE (zebeast@hotmail.com) #
#                                 ( canuckle@lod.com  ) #
#########################################################

source $fserver2_cfg
source $fsetup_tcl

if {![info exists freecredits] || $freecredits == ""} {
  set freecredits "0"
}

if {$enforce == "off"} {set enforce "OFF"}
if {$enforce == "on"} {set enforce "ON"}
if {$enforce != "ON" && $enforce != "OFF"} {set enforce "OFF"}
if {$onjoin == "off"} {set onjoin "OFF"}
if {$onjoin == "on"} {set onjoin "ON"}
if {$onjoin != "ON" && $onjoin != "OFF"} {set onjoin "OFF"}
if {$onjoinmsg == "off"} {set onjoinmsg "OFF"}
if {$onjoinmsg == "on"} {set onjoinmsg "ON"}
if {$onjoinmsg != "ON" && $onjoinmsg != "OFF"} {set onjoinmsg "OFF"}
if {$onjoinnotice == "off"} {set onjoinnotice "OFF"}
if {$onjoinnotice == "on"} {set onjoinnotice "ON"}
if {$onjoinnotice != "ON" && $onjoinnotice != "OFF"} {set onjoinnotice "OFF"}
if {$ratio == "off"} {set ratio "OFF"}
if {$ratio == "on"} {set ratio "ON"}
if {$ratio != "ON" && $ratio != "OFF"} {set ratio "OFF"}
if {![info exists rationumber] || $rationumber == ""} {set rationumber "1:1"}

proc mid {string first last} {return  [string range $string $first $last]}
proc right {string num} {return [mid $string [expr $num + 1] end]}
proc left {string num} {return [mid $string 0 [expr $num - 1]]}

proc check_ratio {} {
  global ratioup ratiodown rationumber
  set ratioup "OFF"
  set ratio1 "OFF"
  set ratiodown "OFF"
  if {[left $rationumber 1] < 10000} {set ratioup [left $rationumber 1]}
  if {[mid $rationumber 1 1] == ":"} {set ratio1 [mid $rationumber 1 1]}
  if {[right $rationumber 1] < 1000} {set ratiodown [right $rationumber 1]}
  if {$ratioup == "OFF" || $ratio1 == "OFF" || $ratiodown == "OFF"} {
    putlog "FServer: There is an error on your ratio! Your Ratio will be enforced into 1:1"
    set rationumber "1:1"
    check_ratio
  }
}

check_ratio

proc autoflush {} {
  users_flush
  check_ratio
  timer 20 autoflush
}

if {![info exists loaded]} {
  putlog "FServer: Initiating Auto-Flush."
  timer 20 autoflush
}


proc findchannels {} {
  global allchannels achannels
  set allchans [channels]
  set 1chan [lindex $allchans 0]
  if {$1chan == ""} {set achannels ""
    return 0}
  set 2chan [lindex $allchans 1]
  if {$2chan == ""} {set achannels $1chan
    return 0}
  set 3chan [lindex $allchans 2]
  if {$3chan == ""} {set achannels $1chan,$2chan
    return 0}
  set 4chan [lindex $allchans 3]
  if {$4chan == ""} {set achannels $1chan,$2chan,$3chan
    return 0}
  set 5chan [lindex $allchans 4]
  if {$5chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan
    return 0}
  set 6chan [lindex $allchans 5]
  if {$6chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan
    return 0}
  set 7chan [lindex $allchans 6]
  if {$7chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan
    return 0}
  set 8chan [lindex $allchans 7]
  if {$8chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan
    return 0}
  set 9chan [lindex $allchans 8]
  if {$9chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan
    return 0}
  set 10han [lindex $allchans 9]
  if {$10chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan
    return 0}
  set 11chan [lindex $allchans 10]
  if {$11chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan
    return 0}
  set 12chan [lindex $allchans 11]
  if {$12chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan
    return 0}
  set 13chan [lindex $allchans 12]
  if {$13chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan
    return 0}
  set 14chan [lindex $allchans 13]
  if {$14chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan
    return 0}
  set 15chan [lindex $allchans 14]
  if {$15chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan,$14chan
    return 0}
  set 16chan [lindex $allchans 15]
  if {$16chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan,$14chan,$15chan
    return 0}
  set 17chan [lindex $allchans 16]
  if {$17chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan,$14chan,$15chan,$16chan
    return 0}
  set 18chan [lindex $allchans 17]
  if {$18chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan,$14chan,$15chan,$16chan,$17chan
    return 0}
  set 19chan [lindex $allchans 18]
  if {$19chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan,$14chan,$15chan,$16chan,$17chan,$18chan
    return 0}
  set 20chan [lindex $allchans 19]
  if {$20chan == ""} {set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan,$14chan,$15chan,$16chan,$17chan,$18chan,$19chan
    return 0}
  set achannels $1chan,$2chan,$3chan,$4chan,$5chan,$6chan,$7chan,$8chan,$9chan,$10chan,$11chan,$12chan,$13chan,$14chan,$15chan,$16chan,$17chan,$18chan,$19chan,$20chan
  return 0
}

findchannels

if {$chanserv == "*"} {
  if {$enforce == "ON"} {
  putlog "FServer: ERROR! CANNOT RUN ENFORCE MODE WHILE"
  putlog "FServer: SERVING ALL THE CHANNELS I'M ON!!!"
  putlog "FServer: Setting Enforce Mode OFF..."
  set enforce "OFF"
  }
}

set flag2 $fserverattr

if {![info exists dcc-incoming]} {
  putlog "FServer: Error! There is no upload directory recognized by the bot! Ignoring upload options."
  putlog "FServer: To set an upload directory, edit your eggdrop configuration file."
}

if {${dcc-incoming} == ""} {
  putlog "FServer: Error! There is no upload directory recognized by the bot! Ignoring upload options."
  putlog "FServer: To set an upload directory, edit your eggdrop configuration file."
}

if {![info exists loaded]} {
  putlog "FServer: Loading Auto Advertise"
  timer 1 advertise
}

proc advertise {} {
  global chanserv trigger relaytime onadvertise achannels advertise
  if { $onadvertise == "ON" } {
    if {$chanserv == "*"} {
      putserv "PRIVMSG $achannels :$advertise"
    }
    if {$chanserv != "*"} {
      putserv "PRIVMSG $chanserv :$advertise"
    }
  timer $relaytime advertise
  }
}

bind dcc m check_maxidle checkidle
proc checkidle {hand idx arg} {check_maxidle}

proc check_maxidle {} {
  global maxidle
  foreach u [userlist q] {
    if {[hand2idx $u] >= 0} {
      if {[getdccidle [hand2idx $u]] > [expr $maxidle * 60]} {
        putdcc [hand2idx $u] "Sorry, but you are being booted for passing the $maxidle minutes Maximun Idle time limit."
        killdcc [hand2idx $u]
        putlog "FServer: Killed $u because he has passed the $maxidle minutes Maximun Idle time limit."
      }
    }
  }
  timer 1 check_maxidle
}

if {![info exists loaded]} {timer 1 check_maxidle}

bind join - * join_auto_notice

proc join_auto_notice {n uh h c} {
  global chanserv trigger onjoin onjoinnotice onjoinmsg joinmsg achannels botnick
  if { $onjoin == "ON" && $n != $botnick} { 
    if { $chanserv == "*" } {
      if { $onjoinnotice == "ON" } {
          putserv "NOTICE $n : $joinmsg"
      }
      if { $onjoinmsg == "ON" } {
          putserv "PRIVMSG $n : $joinmsg - These are the channels I'm on: $achannels"
      }
    }
    if { $c == $chanserv } {
      if { $onjoinnotice == "ON" } {
        putserv "NOTICE $n :$joinmsg"
      }
      if { $onjoinmsg == "ON" } {
        putserv "PRIVMSG $n :$joinmsg - This is the channel I'm on: $chanserv"
      }
    }
  }
}


bind part x "$chanserv *" dcc_part

proc dcc_part {n uh h c} {
  global chanserv checkidx enforce
  if { $enforce == "ON" } {
    if {[matchattr $h n]} { return 0 }
    if {[matchattr $h m]} { return 0 }
    if {[matchattr $h o]} { return 0 }
    if {[matchattr $h j]} { return 0 }
    set checkidx [hand2idx $h]
    if {$checkidx >= 0} {
      putserv "NOTICE $h :You need to be on $chanserv to use my FILESERVER, Sorry!"
      putdcc [hand2idx $h] "You need to be on $chanserv to use my FILESERVER, Sorry!"
      killdcc [hand2idx $h]
      putlog "FServer: Killed $h because he has quit $chanserv."
    }
  }
}

bind pubm - "$chanserv $trigger" pub_server

proc pub_server {nick uhost hand channel rest} {
  global botnick chanserv trigger autopass defaultattr fserverattr
  global delusertemp deluserattr freecredits pcredit

  append userhost $nick "!" [getchanhost $nick $channel]
  set hostmask [maskhost $userhost]
  set target [finduser $hostmask]
  if {$target != "*"} {
    # the target is known by the bot!  
    putserv "NOTICE $nick :Already in my record: \"$target\""
    return 0
  }

  set valid [validuser $nick]
  if {$valid} {
    putserv "NOTICE $nick :Somebody with that handle already exists!"
    return 0
  }
  if {$hostmask == "*"} {
    putlog "FServer Error: $nick's hostmask is '*'"
    putserv "NOTICE $nick :I had an error resolving your hostmask!"
    return 0
  }
  if {![adduser $nick $hostmask]} {
    putserv "NOTICE $nick :Couldn't add \"$nick\" to my user list."
    putserv "NOTICE $nick :I don't know what the problem was =\["
    return 0
  }
  putserv "NOTICE $nick :You have now access to my FILESERVER!"
  putserv "NOTICE $nick :Your password is '$autopass'"
  putserv "NOTICE $nick :You may now DCC CHAT me to reach my FILESERVER."
  putserv "NOTICE $nick :Type /DCC CHAT $botnick to access my FILESERVER."
  putserv "PRIVMSG $nick :Type /DCC CHAT $botnick to access my FILESERVER. Your password is '$autopass'"
  setcomment $nick "Auto-Added by FServer"
  chattr $nick $defaultattr
  chattr $nick $fserverattr
  chpass $nick $autopass
  set pcredit($nick) $freecredits
  save
  putlog "FServer: Successfully added $nick with the attributes $defaultattr to user list"
  return 0
}


bind dcc n commands dcccommands

proc dcccommands { hand idx passed } {
  putdcc $idx " "
  putdcc $idx "   File Server v2.0 by canuckle"
  putdcc $idx "     Command         |  Status"
  putdcc $idx "     ----------------------------------------------------------------"
  putdcc $idx "     .FSETUP         |  Sets up the File Server v2.0 Script"
  putdcc $idx "     .COMMANDS       |  List commands of File Server"
  putdcc $idx "     .FSFLUSH        |  Deletes *ALL* users added by the script accept"
  putdcc $idx "                     |   for the ones that are currently logged on"
  putdcc $idx "     .USERS          |  List users added by the script"
  putdcc $idx "     .FSINFO         |  Information about this File Server"
  putdcc $idx "     .INFO *         |  Information about this File Server"
  putdcc $idx "     .HELP *         |  Upgraded HELP for the File Area"
  putdcc $idx "     .BOOT *         |  Boot someone off the bot"
  putdcc $idx "     .CREDITS *      |  People who are leet"
  putdcc $idx " "
  putdcc $idx "                 * File Area Command"
  return 1
}

bind fil m boot fil_boot

proc fil_boot {hand idx passed} {
  set n [lindex $passed 0]
  set r [lrange $passed 1 end]
  if {$n == ""} {putdcc $idx "Who? No such person in party line.";return 0}
  if {[hand2idx $n] < 0} {putdcc $idx "Who? No such person in party line.";return 0}
  if {[matchattr $n n] && $n != $hand} {putdcc $idx "Can't boot bot owner.";return 0}
  putdcc $idx "Booted $n from the bot."
  putlog "#$hand# files: boot $passed"
  putdcc [hand2idx $n] "-=- poof -=-"
  if {$r == ""} {putdcc [hand2idx $n] "You've been booted from the bot by $hand"}
  if {$r != ""} {putdcc [hand2idx $n] "You've been booted from the bot by $hand: $r"}
  killdcc [hand2idx $n]
}
  

bind dcc m fsflush usr_flush

proc usr_flush { hand idx passed } {users_flush;return 1}

proc users_flush {} {
  global delusertemp deluserattr fserverattr
  putlog "FServer: Now deleting all users in the Bot User List that match the $fserverattr flag (added by the FServer)."
  set users [userlist]
  foreach u $users {
    if {[matchattr $u $fserverattr]} {
      set delusertemp $u
      attr
      check
    }
  }
  putlog "FServer: Done cleaning the File Server User Record"
  save
  return 0
}

proc attr {} {
  global delusertemp deluserattr
  if {[matchattr $delusertemp n]} { set deluserattr 0
    return 0 }
  if {[matchattr $delusertemp m]} { set deluserattr 0
    return 0 }
  if {[matchattr $delusertemp o]} { set deluserattr 0
    return 0 }
  if {[matchattr $delusertemp j]} { set deluserattr 0
    return 0 }
  if {[matchattr $delusertemp f]} { set deluserattr 0
    return 0 }
  if {[matchattr $delusertemp i]} { set deluserattr 0
    return 0 }
  if {[matchattr $delusertemp p]} { set deluserattr 0
    return 0 }
  if {[matchattr $delusertemp x]} {
    set deluserattr 1
    return 0 }
  set deluserattr 0
}

proc check {} {
  global delusertemp deluserattr fserverattr
  if {![matchattr $delusertemp $fserverattr]} { putlog "FServer: Kept $delusertemp on records because he does not have the $fserverattr flag (He was not added by the FileServer)."
    return 0 }
  if { $deluserattr == "1" } {
    set curidx [hand2idx $delusertemp]
    if {$curidx >= 0} {
      putlog "FServer: Kept $delusertemp on records because he is still on the bot. He will be able to be deleted when he quits the bot."
      return 0
    }
    deluser $delusertemp
  }
  if { $deluserattr == "0" } { putlog "FServer: Kept $delusertemp on records because he doesn't match the +x-ipfjomn attributes"
    putlog "FServer: $delusertemp's attributes are [chattr $delusertemp]"}
}

unbind fil - quit *quit

bind fil - quit file_quit

proc file_quit {hand idx arg} {
  global credits fcredits pcredit ratio
  if {[matchattr $hand n] || [matchattr $hand m] || [matchattr $hand o] || [matchattr $hand j]} {
    putdcc $idx "-x- Thanks for using File Server version 2.0 by canuckle"
    killdcc $idx
    putlog "#$hand# files: quit"
    return 0
  }
  if {$ratio == "ON"} {
    if {![info exists pcredit($hand)]} {
      putlog "FServer Error: Don't know $hand's credits, setting it to $freecredits"
      set pcredit($hand) $freecredits
    }
    set quitcredits [set pcredit($hand)]
    putdcc $idx "-x- Your credits are: $quitcredits"
  }
  putdcc $idx "-x- Thanks for using File Server version 2.0 by canuckle"
  killdcc $idx
  putlog "#$hand# files: quit"
  return 0
}

bind dcc m users users_list

proc users_list { hand idx passed } {
  global pcredit fserverattr freecredits
  set usernumber "0"
  putdcc $idx "-x- File Server User List"
  putdcc $idx " #   Credits  Handle"
  foreach u [userlist $fserverattr] {
    set usernumber [expr $usernumber + 1]
    if {![info exists pcredit($u)]} {
      putlog "FServer Error: Don't know $u's credits, setting it to $freecredits"
      set pcredit($u) $freecredits
    }
    set usercredits [set pcredit($u)]
    if {$usercredits < 10} {
      if {$usernumber < 10} {putdcc $idx "\[ $usernumber\]   $usercredits      $u"}
      if {$usernumber > 10} {putdcc $idx "\[$usernumber\]   $usercredits      $u"}
    }
    if {$usercredits >= 10 && $usercredits < 100} {
      if {$usernumber < 10} {putdcc $idx "\[ $usernumber\]  $usercredits      $u"}
      if {$usernumber > 10} {putdcc $idx "\[$usernumber\]  $usercredits      $u"}
    }
    if {$usercredits >= 100 && $usercredits < 1000} {
      if {$usernumber < 10} {putdcc $idx "\[ $usernumber\]  $usercredits     $u"}
      if {$usernumber > 10} {putdcc $idx "\[$usernumber\]  $usercredits     $u"}
    }
    if {$usercredits >= 1000} {
      if {$usernumber < 10} {putdcc $idx "\[ $usernumber\]  $usercredits    $u"}
      if {$usernumber > 10} {putdcc $idx "\[$usernumber\]  $usercredits    $u"}
    }
  }
  putdcc $idx " "
  putdcc $idx "End of List."
  return 1
}

bind msg - $trigger msg_trigger

proc msg_trigger {nick host handle channel} {
  global trigger achannels chanserv
  putserv "PRIVMSG $nick :Sorry, you need to type '$trigger' on a channel I'm on in order to get into my File Server."
  if {$chanserv == "*"} {
    putserv "PRIVMSG $nick :These are the channels I'm on: $achannels"
  }
  if {$chanserv != "*"} {
    putserv "PRIVMSG $nick :This is the channel I'm on: $chanserv"
  }
  return 1
}

bind fil - dir *ls

unbind fil - help *help

bind fil - help fshelp

proc fshelp {hand idx arg} {
  global botnick dcc-incoming ratio pcredit rationumber ratioup ratiodown
  if {[matchattr $hand m]} {
    putdcc $idx "   File Server v2.0 by canuckle"
    putdcc $idx "     handle: $hand      Attributes: [chattr $hand]"
    putdcc $idx "   $botnick File Server comands:   (wildcard expressions are allowed)"
    putdcc $idx "     get <file> \[nick\]     send a file over IRC (DCC send)"
    putdcc $idx "     pending               list queued file transfers"
    putdcc $idx "     cancel <file>         cancel a queued file transfer"
    putdcc $idx "     ls \[filemask\]         show list of files in this directory"
    putdcc $idx "     dir \[filemask\]        show list of files in this directory"
    putdcc $idx "     pwd                   display present working directory"
    putdcc $idx "     cd <dir>              change current directory"
    putdcc $idx "     desc <file> <desc>    set description of <file> to <desc>"
    putdcc $idx "     who                   see who are logged on the bot right now"
    putdcc $idx "     note <handle> <msg>   to send someone a message"
    putdcc $idx "     credits               see how many download credits you have"
    putdcc $idx "     quit                  leave the file system"
    putdcc $idx "   Masters only:"
    putdcc $idx "     hide      share     mkdir     cp        rm        lsa"
    putdcc $idx "     unhide    unshare   rmdir     mv        ln        boot"
    if {${dcc-incoming} == ""} { return 1 }
    if {![info exists dcc-incoming]} { return 1 }
    putdcc $idx "    _________________________________________________________"
    putdcc $idx "   (               Feel free to upload a file                )"
    putdcc $idx "   (     To upload a file, just start your dcc transfer.     )"
    putdcc $idx "   (Your nick will be attached with the file that you upload.)"
    putdcc $idx "   (_________________________________________________________)"
    putdcc $idx " "
    putdcc $idx "   Type 'info' for information about File Server."
    putdcc $idx " "
    if {$ratio == "ON"} {
      putdcc $idx "   Ratio is turned ON. Ratio is counted by FILES, not SIZE."
      putdcc $idx "   Ratio of $rationumber (upload $ratioup, download $ratiodown)"
    }
    if {$ratio != "ON"} { putdcc $idx "   Ratio is turned OFF"}
    return 1
  }
  putdcc $idx "   File Server v2.0 by canuckle"
  putdcc $idx "     handle: $hand      Attributes: [chattr $hand]"
  putdcc $idx "   $botnick File Server comands:   (wildcard expressions are allowed)"
  putdcc $idx "     get <file> \[nick\]     send a file over IRC (DCC send)"
  putdcc $idx "     pending               list queued file transfers"
  putdcc $idx "     cancel <file>         cancel a queued file transfer"
  putdcc $idx "     ls \[filemask\]         show list of files in this directory"
  putdcc $idx "     dir \[filemask\]        show list of files in this directory"
  putdcc $idx "     pwd                   display present working directory"
  putdcc $idx "     cd <dir>              change current directory"
  putdcc $idx "     desc <file> <desc>    set description of <file> to <desc>"
  putdcc $idx "     who                   see who are logged on the bot now"
  putdcc $idx "     note <handle> <msg>   to send someone a message"
  putdcc $idx "     credits               see how many download credits you have"
  putdcc $idx "     quit                  leave the file system"
  if {${dcc-incoming} == ""} { return 1 }
  if {![info exists dcc-incoming]} { return 1 }
  putdcc $idx "    _________________________________________________________"
  putdcc $idx "   (               Feel free to upload a file                )"
  putdcc $idx "   (     To upload a file, just start your dcc transfer.     )"
  putdcc $idx "   (Your nick will be attached with the file that you upload.)"
  putdcc $idx "   (_________________________________________________________)"
  putdcc $idx " "
  putdcc $idx "   Type 'info' for information about File Server."
  putdcc $idx " "
  if {$ratio == "ON"} {
    putdcc $idx "   Ratio is turned ON. Ratio is counted by FILES, not SIZE."
    putdcc $idx "   Ratio of $rationumber (upload $ratioup, download $ratiodown)"
  }
  if {$ratio != "ON"} { putdcc $idx "   Credits are OFF"}
  if {$ratio == "ON"} {
    if {![info exists pcredit($hand)]} {
      putlog "FServer Error: Don't know $hand's credits, setting it to $freecredits"
      set pcredit($hand) $freecredits
    }
    set helpcredits [set pcredit($hand)]
    putdcc $idx " "
    putdcc $idx "     Your credits are: $helpcredits"
  }

  return 1
}

unbind dcc n die *die

bind dcc n die dcc_die

proc dcc_die { hand idx passed } {
  set reason [lrange $passed 0 end]
  putlog "#$hand# die"
  putlog "FServer: Flushing File Server User Record before killing eggdrop..."
  users_flush
  die $reason
}

bind fil - credits fcredits

proc fcredits {hand idx arg} {
  global pcredit ratio rationumber ratioup ratiodown
  if {$ratio == "ON"} {
    putdcc $idx "Ratio is turned ON. Ratio is counted by FILES, not SIZE."
    putdcc $idx "Ratio is $rationumber (upload $ratioup, download $ratiodown)"
  }
  if {$ratio != "ON"} {putdcc $idx "Ratio is turned OFF"}
  if {[matchattr $hand n] || [matchattr $hand m] || [matchattr $hand o] || [matchattr $hand j]} {putdcc $idx "You have unlimited/leech access";return 1}
  if {![info exists pcredit($hand)]} {
    putlog "FServer Error: Don't know $hand's credits, setting it to $freecredits"
    set pcredit($hand) $freecredits
  }
  set creditsratio [set pcredit($hand)]
  putdcc $idx "Your current Credits are: $creditsratio"
  return 1
}

bind fil - who fwho

proc fwho {hand idx arg} {
  set usernumber "0"
  set users [userlist]
  putdcc $idx "-x- Current users online"
  putdcc $idx "  #   Handle/Attributes"
  foreach u $users {
    if {[hand2idx $u] >= 0} {
      set usernumber [expr $usernumber + 1]
      if {[matchattr $u n] || [matchattr $u m] || [matchattr $u o] || [matchattr $u j]} {
        if {$usernumber < 10} {putdcc $idx "\[ $usernumber\]  $u / [chattr $u]"}
        if {$usernumber > 10} {putdcc $idx "\[$usernumber\]  $u / [chattr $u]"}
      }
      if {![matchattr $u n] && ![matchattr $u m] && ![matchattr $u o] && ![matchattr $u j]} {
        if {$usernumber < 10} {putdcc $idx "\[ $usernumber\]  $u / [chattr $u]"}
        if {$usernumber > 10} {putdcc $idx "\[$usernumber\]  $u / [chattr $u]"}
      }
    }
  }
  putdcc $idx " "
  putdcc $idx "End of List."
  putdcc $idx "Type \".note <handle> <message>\" to send a message to someone"
  return 1
}

bind dcc - fsinfo fsinfo
bind fil - info fsinfo

proc fsinfo {hand idx arg} {
  global admin version owner
  putdcc $idx "(  File Server version 2.0 by canuckle(zebeast@hotmail.com)  )"
  putdcc $idx "     Administrator of this bot:        $admin"
  putdcc $idx "     Version of this eggdrop bot:      $version"
  putdcc $idx "     Permanent Owner of this bot:      $owner"
  putdcc $idx " "
  putdcc $idx "(              File Server version 2.0 Credits               )"
  putdcc $idx " gambitx shadow  GreyEyes JF CrAsS kMaRtCwBy  saraH Chak Vipe"
  putdcc $idx " QuaziModo crusad0r Roc--D  zerox Wisher tHREAt Creator \]WoF\["
  putdcc $idx " eternal d0rk karnage bice ^LordMC^  KraziThug c|0ne Pt_ jax`"
  putdcc $idx " Dredc0n tanky SaGaT_ int3loper  WoofMeow doobie luigi biogen"
  putdcc $idx " dose  Hackster  \[rocko\]  |Scout|0  SteveG  i76  GauZe_  aCk-"
  putdcc $idx " FLoodland  Adapt9  marc b0red  mAtt-t  Morta| xaos  wong amk"
  putdcc $idx " xavi1  Acid_Jack  h4sh  HyAdEs  promo  Sticky_J  COP  evilz-"
  putdcc $idx " frashalso toasted_ _Jules_  cyphaetus  _erb soulz kult Lem0n"
  putdcc $idx " fearz-  obscene  SteelRat  vain  ^Badger^ Camel  RabiD void_"
  putdcc $idx " kandikis \[976\] n0VarTis AdvisoryX hype_  soulgrind \[glacius\]"
  putdcc $idx " fluteloop kbs l0sEr stelent Dv8tiom Good DeTHN|GHT miel nads"
  putdcc $idx " "
  return 1
}

unbind fil x get *get

bind fil x get file_get

proc file_get {hand idx arg} {
  global chanserv checkidx enforce ratio pcredit rationumber ratioup ratiodown
  set filename [lindex $arg 0]
  set nickname [lindex $arg 1]
  if {$filename == ""} {
    putdcc $idx "Syntax: get <filename> \[nick\]"
    return 0
  }
  if {[matchattr $hand n] || [matchattr $hand m] || [matchattr $hand o] || [matchattr $hand j]} {
    if {$nickname == ""} {
      if {![filesend $idx $filename]} {
        putdcc $idx "Error Sending File! Try again."
        return 0
      }
      putdcc $idx "Sending file $filename... Your credits are not being counted."
      return 1
    }
    if {$nickname != ""} {
      if {![filesend $idx $filename $nickname]} {
        putdcc $idx "Error Sending File! Try again."
        return 0
      }
      putdcc $idx "Sending file $filename to $nickname... Your credits are not being counted."
      return 1
    }
  }
  if { $enforce == "ON" } {
    if {![onchan $hand $chanserv]} {
      putdcc $idx "You need to be on $chanserv to use my FILESERVER, $nickname is not on $chanserv. Sorry!"
      killdcc $idx
      putlog "FServer: Killed $hand because he was downloading from outside $chanserv."
      return 1
    }
  }
  if {[set pcredit($hand)] <= 0 && $ratio == "ON"} {
    putdcc $idx "Sorry, you do not have enough credits to download $filename!"
    putdcc $idx "Please upload on a ratio of $rationumber (upload $ratioup, download $ratiodown)"
    return 0
  }
  if {$nickname == ""} {
    if {![filesend $idx $filename]} {
      putdcc $idx "Error Sending File! Try again."
      return 0
    }
    if {$ratio == "ON"} {putdcc $idx "Sending file $filename... Your credits will be [expr [set pcredit($hand)] - 1] when you're finished downloading."}
    if {$ratio == "OFF"} {putdcc $idx "Sending file $filename..."}
    return 1
  }
  if {$nickname != ""} {
    if {![filesend $idx $filename $nickname]} {
      putdcc $idx "Error Sending File! Try again."
      return 0
    }
    if {$ratio == "ON"} {putdcc $idx "Sending file $filename... Your credits will be [expr [set pcredit($hand)] - 1] when you're finished downloading."}
    if {$ratio == "OFF"} {putdcc $idx "Sending file $filename..."}
    return 1
  }
}

bind sent - * fil_sent

proc fil_sent {hand nick pathtofile} {
  global chanserv checkidx enforce ratio pcredit rationumber ratioup ratiodown
  set checkidx [hand2idx $hand]
  if {[matchattr $hand n] || [matchattr $hand m] || [matchattr $hand o] || [matchattr $hand j]} {
    if {$checkidx >= 0} {
      putdcc [hand2idx $hand] "Finished sending file."
      return 0
    }
    if {$checkidx < 0} {
      putserv "PRIVMSG $nick :Finished sending file."
      return 0
    }
  }
  if {$ratio == "ON"} {
    if {![info exists pcredit($hand)]} {
      putlog "FServer Error: Don't know $hand's credits, setting it to $freecredits"
      set pcredit($hand) $freecredits
    }
    set pcredit($hand) [expr [set pcredit($hand)] - 1]
  }
  if {$checkidx >= 0} {
    if {$ratio == "ON"} {
      if {[set pcredit($hand)] <= 0} {
        putdcc [hand2idx $hand] "You have no more credits left. Please upload more for more credits. ([set pcredit($hand)] credits)."
      }
      if {[set pcredit($hand)] > 0} {
        putdcc [hand2idx $hand] "Finished sending file. You now have [set pcredit($hand)] credits!"
      }
      putdcc [hand2idx $hand] "Ratio is $rationumber (upload $ratioup, download $ratiodown)."
    }
    if { $enforce == "ON" } {
      if {![onchan $hand $chanserv]} {
        if {[hand2idx $hand] < 0} {putserv "NOTICE $nick :You need to be on $chanserv to use my FILESERVER, $nick is not on $chanserv. Sorry!"}
        if {[hand2idx $hand] >= 0} {
          putdcc [hand2idx $hand] "You need to be on $chanserv to use my FILESERVER, $nick is not on $chanserv. Sorry!"
          killdcc [hand2idx $hand]
          putlog "FServer: Killed $hand because he was downloading from outside $chanserv."
        }
        return 1
      }
    }
  }
  if {$ratio == "ON" && $checkidx < 0} {
    if {[set pcredit($hand)] <= 0} {
      putserv "PRIVMSG $hand :You have no more credits left. Please upload more for more credits. ([set pcredit($hand)] credits)."
    }
    if {[set pcredit($hand)] > 0} {
      putserv "PRIVMSG $hand :Finished sending file. You now have [set pcredit($hand)] credits!"
    }
    putserv "PRIVMSG $hand :Ratio is $rationumber (upload $ratioup, download $ratiodown)."
  }
}

bind rcvd - * fil_received

proc fil_received {hand nick pathtofile} {
  global chanserv checkidx enforce ratio pcredit rationumber ratioup ratiodown freecredits
  set checkidx [hand2idx $hand]
  if {[matchattr $hand n] || [matchattr $hand m] || [matchattr $hand o] || [matchattr $hand j]} {
    if {$checkidx >= 0} {
      putdcc [hand2idx $hand] "Thanks for sending file."
      putdcc [hand2idx $hand] "To set a description to the file, type:"
      putdcc [hand2idx $hand] "  desc <filename> <description>"
      return 0
    }
    if {$checkidx < 0} {
      putserv "PRIVMSG $nick :Thanks for sending file."
      return 0
    }
  }
  if {$ratio == "ON"} {
    if {![info exists pcredit($hand)]} {
      putlog "FServer Error: Don't know $hand's credits, setting it to $freecredits"
      set pcredit($hand) $freecredits
    }
    set pcredit($hand) [expr [set pcredit($hand)] + (1 * $ratiodown)/$ratioup ]
  }
  if {$checkidx >= 0} {
    if {$ratio == "ON"} {
      if {[set pcredit($hand)] <= 0} {
        putdcc [hand2idx $hand] "You have no more credits left. Please upload more for more credits. ([set pcredit($hand)] credits)."
      }
      if {[set pcredit($hand)] > 0} {
        putdcc [hand2idx $hand] "Finished receiving file. You now have [set pcredit($hand)] credits!"
      }
      putdcc [hand2idx $hand] "Ratio is $rationumber (upload $ratioup, download $ratiodown)."
      putdcc [hand2idx $hand] "To set a description to the file, type:"
      putdcc [hand2idx $hand] "  desc <filename> <description>"
    }
    if { $enforce == "ON" } {
      if {![onchan $hand $chanserv]} {
        if {[hand2idx $hand] < 0} {putserv "NOTICE $nick :You need to be on $chanserv to use my FILESERVER, $nick is not on $chanserv. Sorry!"}
        if {[hand2idx $hand] >= 0} {
          putdcc [hand2idx $hand] "You need to be on $chanserv to use my FILESERVER, $nick is not on $chanserv. Sorry!"
          killdcc [hand2idx $hand]
          putlog "FServer: Killed $hand because he was downloading from outside $chanserv."
        }
        return 1
      }
    }
  }
  if {$ratio == "ON" && $checkidx < 0} {
    if {[set pcredit($hand)] <= 0} {
      putserv "PRIVMSG $hand :You have no more credits left. Please upload more for more credits. ([set pcredit($hand)] credits)."
    }
    if {[set pcredit($hand)] > 0} {
      putserv "PRIVMSG $hand :Finished sending file. You now have [set pcredit($hand)] credits!"
    }
    putserv "PRIVMSG $hand :Ratio is $rationumber (upload $ratioup, download $ratiodown)."
  }
}

if {![info exists loaded]} {users_flush}

proc fserver_save {} {
  global fserver2_cfg chanserv trigger autopass defaultattr fserverattr enforce maxidle
  global ratio rationumber freecredits onjoin onjoinmsg onjoinnotice joinmsg
  global onadvertise advertise relaytime
  set fserverfile [open $fserver2_cfg w+]
  puts $fserverfile "
# THIS IS THE STUFF YOU NEED TO CONFIGURE!

########## Regular stuff ##########

# Channel to serve, \"*\" for all channels
# (This is the channel that the bot will
# be serving):
# *** THIS IS CASE SENSITIVE ***
set chanserv \"$chanserv\"

# Trigger command (This is what an user must
# time on the channel the bot is serving to
# be added to the bot):
set trigger \"$trigger\"

# Password to auto-set on trigger command
# (This is the password the bot will autoset
# whenever someone types the trigger command
# from the channel the bot is serving):
set autopass \"$autopass\"

# Auto set attributes (This is what the
# default attributes of someone who types
# the trigger command on the channel will
# automaticly be set to, IF YOU ARE NOT
# AN EXPERIENCED EGGDROP USER, DO NOT
# CHANGE THIS!):
set defaultattr \"$defaultattr\"

# File Server Attribute (This is the
# attribute that all people added
# but the File Server will have.
# this has to be a non-existent
# attribute. This has not to be
# changed)
set fserverattr \"$fserverattr\"

# Turn Efforce ON or OFF (If turned on, the
# bot will only serve people from the
# channel the bot is - really good option
# when you are the operator of that channel)
# PS: If your bot is serving ALL channel it
# is on, leave it off!
set enforce \"$enforce\"

# Maximun Idle Time (This is the maximun
# time that a File Server User can stay
# logged on the Bot without typing a
# command. If the user passes this limit,
# he is automaticly booted from the bot)
set maxidle \"$maxidle\"

############ RATIO Options ############

# Turn RATIO ON or OFF (If turned \"ON\",
# the server won't serve for free.
# If turned \"OFF\", the server will
# serve people for free.):
set ratio \"$ratio\"

# Type Ratio Number that you want
# (Example if it is set to \"1:2\", then
# the File Server User will be able
# to download 2 files every 1 file
# he/she sends. If it is set to \"1:1\",
# the File Server User will be able
# to download 1 file every 1 file
# he/she sends.):
set rationumber \"$rationumber\"

# Free Credits (This is how many free
# files that you will give out to each
# new File Server User. If it is set
# to \"1\", every new User will begin
# with 1 free file for download.
set freecredits \"$freecredits\"

########## Auto JOIN options ##########

# Turn JOIN messages ON or OFF (If turned
# \"ON\", this will send either a message or/and
# notice to someone who joins the channel that
# the bot is serving):
set onjoin \"$onjoin\"

# On Join /MSG ON or OFF (If turned \"ON\",
# this will auto MESSAGE someone when he joins
# the channel that the bot is serving):
set onjoinmsg \"$onjoinmsg\"

# On join /NOTICE ON or OFF (If turned \"ON\",
# this will auto NOTICE someone when he joins
# the channel that the bot is serving):
set onjoinnotice \"$onjoinnotice\"

# On Join Message (This will be the message
# that the bot will send when someone joins
# the channel if either ON JOIN /NOTICE or/and
# ON JOIN /MSG is on):
set joinmsg \"$joinmsg\"

########## Advertising options ##########

# Turn Advertising ON or OFF (If turned \"ON\",
# the bot will auto send a timed advertise to
# the channel it is serving):
set onadvertise \"$onadvertise\"

# Advertise line (This is the timed message
# that the bot will auto send the channel):
set advertise \"$advertise\"

# Relay time to Advertise (This is the time
# on which the bot will wait between the
# advertise it is sending):
set relaytime \"$relaytime\"

# YOU ARE DONE! YOU CAN NOW RUN THE EGGDROP
"
  close $fserverfile
}

fserver_save

# THIS WILL STOP THE BOT LOADING THE VARIABLES
# AND AUTO-ADVERTISE MORE THAN ONCE!
# DO NOT TOUCH THIS OR YOU'LL HAVE BUGS!
set loaded 1


putlog "FServer: Type .fsetup to setup script, .commands to see commands,"
putlog "          and .fsinfo for File Server Info."
putlog "( FServer v2.0 ) by canuckle loaded."


